<?php 
class ControllerPaymentWorldNetHPP extends Controller {
	private $error = array(); 
	
	public function index() {
		$this->load->language('payment/worldnethpp');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->load->model('setting/setting');
			$this->model_setting_setting->editSetting('worldnethpp', $this->request->post);				
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_payment'] = $this->language->get('text_payment');
		$data['text_worldnet'] = $this->language->get('text_worldnet');
		$data['text_cashflows'] = $this->language->get('text_cashflows');
		$data['text_pagotechnology'] = $this->language->get('text_pagotechnology');
		$data['text_payius'] = $this->language->get('text_payius');
 		$data['text_globalonepay'] = $this->language->get('text_globalonepay');
		$data['text_anywherecommerce'] = $this->language->get('text_anywherecommerce');
		$data['text_ctpayments'] = $this->language->get('text_ctpayments');
		$data['text_payconexplus'] = $this->language->get('text_payconexplus');
		$data['text_payzone'] = $this->language->get('text_payzone');
		$data['text_success'] = $this->language->get('text_success');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_true'] = $this->language->get('text_true');
		$data['text_false'] = $this->language->get('text_false');
		$data['currency_eur'] = $this->language->get('currency_eur');
		$data['currency_gbp'] = $this->language->get('currency_gbp');
		$data['currency_usd'] = $this->language->get('currency_usd');
		$data['currency_sek'] = $this->language->get('currency_sek');
		$data['currency_dkk'] = $this->language->get('currency_dkk');
		$data['currency_nok'] = $this->language->get('currency_nok');
		$data['currency_aud'] = $this->language->get('currency_aud');
		$data['currency_cad'] = $this->language->get('currency_cad');
		$data['tab_account'] = $this->language->get('tab_account');
		$data['tab_order_status'] = $this->language->get('tab_order_status');
		$data['entry_gateway'] = $this->language->get('entry_gateway');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_test'] = $this->language->get('entry_test');
		$data['entry_currency1'] = $this->language->get('entry_currency1');
		$data['entry_currency1_tip'] = $this->language->get('entry_currency1_tip');
		$data['entry_terminal1'] = $this->language->get('entry_terminal1');
		$data['entry_terminal1_tip'] = $this->language->get('entry_terminal1_tip');
		$data['entry_secret1'] = $this->language->get('entry_secret1');
		$data['entry_secret1_tip'] = $this->language->get('entry_secret1_tip');
		$data['entry_currency2'] = $this->language->get('entry_currency2');
		$data['entry_terminal2'] = $this->language->get('entry_terminal2');
		$data['entry_secret2'] = $this->language->get('entry_secret2');
		$data['entry_currency3'] = $this->language->get('entry_currency3');
		$data['entry_terminal3'] = $this->language->get('entry_terminal3');
		$data['entry_secret3'] = $this->language->get('entry_secret3');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_send_receipt'] = $this->language->get('entry_send_receipt');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['error_permission'] = $this->language->get('error_permission');
		$data['error_terminal1'] = $this->language->get('error_terminal1');
		$data['error_secret1'] = $this->language->get('error_secret1');
		$data['error_secret1_tip'] = $this->language->get('error_secret1_tip');
		$data['entry_status_success'] = $this->language->get('entry_status_success');
		$data['entry_status_declined'] = $this->language->get('entry_status_declined');
		$data['entry_status_failed'] = $this->language->get('entry_status_failed');

 		if (isset($this->error['warning'])) $data['error_warning'] = $this->error['warning'];
		else $data['error_warning'] = '';

 		if (isset($this->error['gateway'])) $data['error_gateway'] = $this->error['gateway'];
		else $data['error_gateway'] = '';

  		if (isset($this->error['terminal1'])) $data['error_terminal1'] = $this->error['terminal1'];
		else $data['error_terminal1'] = '';

 		if (isset($this->error['secret1'])) $data['error_secret1'] = $this->error['secret1'];
		else $data['error_secret1'] = '';

  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
	       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
	       		'text'      => $this->language->get('text_home'),
	      		'separator' => FALSE
   		);

   		$data['breadcrumbs'][] = array(
	       		'href'      => HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'],
	       		'text'      => $this->language->get('text_payment'),
	      		'separator' => ' :: '
   		);

   		$data['breadcrumbs'][] = array(
	       		'href'      => HTTPS_SERVER . 'index.php?route=payment/worldnethpp&token=' . $this->session->data['token'],
	       		'text'      => $this->language->get('heading_title'),
	      		'separator' => ' :: '
   		);

		$data['action'] = HTTPS_SERVER . 'index.php?route=payment/worldnethpp&token=' . $this->session->data['token'];
		$data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'];
		
		if (isset($this->request->post['worldnethpp_gateway'])) $data['worldnethpp_gateway'] = $this->request->post['worldnethpp_gateway'];
		else $data['worldnethpp_gateway'] = $this->config->get('worldnethpp_gateway');

		if (isset($this->request->post['worldnethpp_currency1'])) $data['worldnethpp_currency1'] = $this->request->post['worldnethpp_currency1'];
		else $data['worldnethpp_currency1'] = $this->config->get('worldnethpp_currency1');

		if (isset($this->request->post['worldnethpp_terminal1'])) $data['worldnethpp_terminal1'] = $this->request->post['worldnethpp_terminal1'];
		else $data['worldnethpp_terminal1'] = $this->config->get('worldnethpp_terminal1');

		if (isset($this->request->post['worldnethpp_secret1'])) $data['worldnethpp_secret1'] = $this->request->post['worldnethpp_secret1'];
		else $data['worldnethpp_secret1'] = $this->config->get('worldnethpp_secret1');

		if (isset($this->request->post['worldnethpp_currency2'])) $data['worldnethpp_currency2'] = $this->request->post['worldnethpp_currency2'];
		else $data['worldnethpp_currency2'] = $this->config->get('worldnethpp_currency2');

		if (isset($this->request->post['worldnethpp_terminal2'])) $data['worldnethpp_terminal2'] = $this->request->post['worldnethpp_terminal2'];
		else $data['worldnethpp_terminal2'] = $this->config->get('worldnethpp_terminal2');
		
		if (isset($this->request->post['worldnethpp_secret2'])) $data['worldnethpp_secret2'] = $this->request->post['worldnethpp_secret2'];
		else $data['worldnethpp_secret2'] = $this->config->get('worldnethpp_secret2');

		if (isset($this->request->post['worldnethpp_currency3'])) $data['worldnethpp_currency3'] = $this->request->post['worldnethpp_currency3'];
		else $data['worldnethpp_currency3'] = $this->config->get('worldnethpp_currency3');

		if (isset($this->request->post['worldnethpp_terminal3'])) $data['worldnethpp_terminal3'] = $this->request->post['worldnethpp_terminal3'];
		else $data['worldnethpp_terminal3'] = $this->config->get('worldnethpp_terminal3');

		if (isset($this->request->post['worldnethpp_secret3'])) $data['worldnethpp_secret3'] = $this->request->post['worldnethpp_secret3'];
		else $data['worldnethpp_secret3'] = $this->config->get('worldnethpp_secret3');

		if (isset($this->request->post['worldnethpp_test'])) $data['worldnethpp_test'] = $this->request->post['worldnethpp_test'];
		else $data['worldnethpp_test'] = $this->config->get('worldnethpp_test');

		if (isset($this->request->post['worldnethpp_status_success'])) $data['worldnethpp_status_success'] = $this->request->post['worldnethpp_status_success'];
		else $data['worldnethpp_status_success'] = $this->config->get('worldnethpp_status_success');

		if (isset($this->request->post['worldnethpp_status_declined'])) $data['worldnethpp_status_declined'] = $this->request->post['worldnethpp_status_declined'];
		else $data['worldnethpp_status_declined'] = $this->config->get('worldnethpp_status_declined');

		if (isset($this->request->post['worldnethpp_status_failed'])) $data['worldnethpp_status_failed'] = $this->request->post['worldnethpp_status_failed'];
		else $data['worldnethpp_status_failed'] = $this->config->get('worldnethpp_status_failed');

		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['worldnethpp_status'])) $data['worldnethpp_status'] = $this->request->post['worldnethpp_status'];
		else $data['worldnethpp_status'] = $this->config->get('worldnethpp_status');

		if (isset($this->request->post['worldnethpp_send_receipt'])) $data['worldnethpp_send_receipt'] = $this->request->post['worldnethpp_send_receipt'];
		else $data['worldnethpp_send_receipt'] = $this->config->get('worldnethpp_send_receipt');

		if (isset($this->request->post['worldnethpp_sort_order'])) $data['worldnethpp_sort_order'] = $this->request->post['worldnethpp_sort_order'];
		else $data['worldnethpp_sort_order'] = $this->config->get('worldnethpp_sort_order');

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/worldnethpp.tpl', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/worldnethpp')) $this->error['warning'] = $this->language->get('error_permission');
		if (!$this->request->post['worldnethpp_gateway']) $this->error['gateway'] = $this->language->get('error_gateway');
		if (!$this->request->post['worldnethpp_terminal1']) $this->error['terminal1'] = $this->language->get('error_terminal1');
		if (!$this->request->post['worldnethpp_secret1']) $this->error['secret1'] = $this->language->get('error_secret1');
		if (!$this->error) return TRUE;
		else return FALSE;
	}
}
?>
